function serverCmdRG( %cl, %name )
{
	if ( !isObject( %pl = %cl.player ) )
	{
		return;
	}

	if ( isObject( %mg = %cl.miniGame ) )
	{
		if ( %name $= "wand" && !%mg.enableWand )
		{
			%cl.centerPrint( "\c5You cannot use this tool right now.", 2 );
			return;
		}
		else if ( !%mg.enableBuilding )
		{
			%cl.centerPrint( "\c5You cannot use this tool right now.", 2 );
			return;
		}
	}

	switch$ ( %name )
	{
		case "hammer": %image = rangeHammerImage;
		case "wrench": %image = rangeWrenchImage;
		case "printer": %image = rangePrinterImage;
		case "wand": %image = rangeWandImage;
	}

	if ( !isObject( %image ) )
	{
		%name = trim( stripMLControlChars( %name ) );

		%cl.centerPrint( "\c5There is no ranged tool named \c3" @ %name @ "\c5.", 2 );
		return;
	}

	%pl.mountImage( %image, 0 );
	fixArmReady( %pl );
}

// Ranged Hammer

datablock itemData( rangeHammerItem : hammerItem )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	uiName = "Range Hammer";
	image = rangeHammerImage;
};

datablock shapeBaseImageData( rangeHammerImage : hammerImage )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	item = rangeHammerItem;
};

function rangeHammerImage::onFire( %this, %obj, %slot )
{
	%start = %obj.getEyePoint();
	%stop = vectorAdd( %start, vectorScale( %obj.getEyeVector(), 100 ) );
	%ray = containerRayCast( %start, %stop, $typeMasks::All, %obj );

	if ( isObject( %col = firstWord( %ray ) ) )
	{
		hammerImage.onHitObject( %obj, %slot, %col );
	}
}

// Ranged Wrench

datablock itemData( rangeWrenchItem : wrenchItem )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	uiName = "Range Wrench";
	image = rangeWrenchImage;
};

datablock shapeBaseImageData( rangeWrenchImage : wrenchImage )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	item = rangeWrenchItem;
};

function rangeWrenchImage::onFire( %this, %obj, %slot )
{
	%start = %obj.getEyePoint();
	%stop = vectorAdd( %start, vectorScale( %obj.getEyeVector(), 100 ) );
	%ray = containerRayCast( %start, %stop, $typeMasks::All, %obj );

	if ( isObject( %col = firstWord( %ray ) ) )
	{
		wrenchImage.onHitObject( %obj, %slot, %col );
	}
}

// Ranged Printer

datablock itemData( rangePrinterItem : printGun )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	uiName = "Range Printer";
	image = rangePrinterImage;
};

datablock shapeBaseImageData( rangePrinterImage : printGunImage )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	item = rangePrinterItem;
};

function rangePrinterImage::onFire( %this, %obj, %slot )
{
	%start = %obj.getEyePoint();
	%stop = vectorAdd( %start, vectorScale( %obj.getEyeVector(), 100 ) );
	%ray = containerRayCast( %start, %stop, $typeMasks::All, %obj );

	if ( isObject( %col = firstWord( %ray ) ) )
	{
		printGunImage.onHitObject( %obj, %slot, %col );
	}
}

// Ranged Wand

datablock itemData( rangeWandItem : wandItem )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	uiName = "Range Wand";
	image = rangeWandImage;
};

datablock shapeBaseImageData( rangeWandImage : wandImage )
{
	doColorShift = true;
	colorShiftColor = "0.4 1 0.4 1";

	item = rangeWandItem;
};

function rangeWandImage::onFire( %this, %obj, %slot )
{
	%start = %obj.getEyePoint();
	%stop = vectorAdd( %start, vectorScale( %obj.getEyeVector(), 100 ) );
	%ray = containerRayCast( %start, %stop, $typeMasks::All, %obj );

	if ( isObject( %col = firstWord( %ray ) ) )
	{
		wandImage.onHitObject( %obj, %slot, %col );
	}
}